unit Game.Intf;

interface
uses
  System.Generics.Collections;


type
  IGameNetwork = interface
    ['{0B1445D2-E6B7-45FD-98CB-A76F01B9D4B8}']
    function GetServerPort: Integer;
    function GetPeerPort: Integer;
    function GetQueryPort: Integer;

    procedure SetServerPort(const Value: Integer);
    procedure SetPeerPort(const Value: Integer);
    procedure SetQueryPort(const Value: Integer);

    property ServerPort: Integer read GetServerPort write SetServerPort;
    property PeerPort: Integer read GetPeerPort write SetPeerPort;
    property QueryPort: Integer read GetQueryPort write SetQueryPort;
  end;


  IGameName = interface
    ['{44A04A0D-BE01-42B7-8EF1-7EC5CC431B66}']
    function GetServerName: string;
    function GetMessageOfTheDay: string;

    procedure SetServerName(const Value: string);
    procedure SetMessageOfTheDay(const Value: string);

    property ServerName: string read GetServerName write SetServerName;
    property MessageOfTheDay: string read GetMessageOfTheDay write SetMessageOfTheDay;
  end;


  IGameMap = interface
    ['{B50A090C-3731-401F-91B5-0895CBE99921}']
    function GetCategory: string;
    function GetName: string;
    function GetDisplayName: string;

    property Category: string read GetCategory;
    property Name: string read GetName;
    property DisplayName: string read GetDisplayName;
  end;


  IGameMapList = interface
    ['{E8552B4C-9447-4FAD-BB20-C5EB3AF07B0E}']
    function GetSupportedMapList: TList<IGameMap>;
    function GetMapList: TList<string>;
  end;


implementation

end.
